// Copyright (c) 2024 Codemongous LLC. All Rights Reserved.

#pragma once
#include "ISCW_UObject.h"

#include <memory>
#include <string>

using std::shared_ptr;
using std::wstring;

namespace Sourcify
{	
	class ISCW_UInterface : public virtual ISCW_UObject
	{
	public:
		virtual ~ISCW_UInterface() = default;
		
		virtual shared_ptr<ISCW_UInterface> ToUInterfacePtr() = 0;
		virtual shared_ptr<const ISCW_UInterface> ToUInterfacePtr() const = 0;
	};

	using ISCW_UInterfaceConstPtr = shared_ptr<const ISCW_UInterface>;
	using ISCW_UInterfacePtr = shared_ptr<ISCW_UInterface>;
} // namespace Sourcify